#include "LBBCSampleConfigFile.h"

namespace LBBC {

SampleConfigFile::SampleConfigFile(): Ogre::ConfigFile()
{
}
	
SampleConfigFile::~SampleConfigFile()
{
}

Ogre::String SampleConfigFile::getEntitySampleMaterialName()
{
	return getSetting("Entity Sample Material Name");
}

Ogre::String SampleConfigFile::getEntitySampleMeshName()
{
	return getSetting("Entity Sample Mesh Name");
}

bool SampleConfigFile::getEntityDistributionGeneration()
{
	return Ogre::StringConverter::parseBool(getSetting("Entity Distribution Generation"));
}

bool SampleConfigFile::getEntityDistributionMerged()
{
	return Ogre::StringConverter::parseBool(getSetting("Entity Distribution Merged"));
}

Ogre::String SampleConfigFile::getEntityDistributionSplittedMeshName()
{
	return getSetting("Entity Distribution Splitted Mesh Name");
}

Ogre::String SampleConfigFile::getEntityDistributionSplittedMaterialName()
{
	return getSetting("Entity Distribution Splitted Material Name");
}

Ogre::String SampleConfigFile::getEntityDistributionMergedMeshName()
{
	return getSetting("Entity Distribution Merged Mesh Name");
}

Ogre::String SampleConfigFile::getEntityDistributionMergedMaterialName()
{
	return getSetting("Entity Distribution Merged Material Name");
}

Ogre::String SampleConfigFile::getEntityDistributionFolder()
{
	return getSetting("Entity Distribution Folder");
}

Ogre::String SampleConfigFile::getEntityDistributionXMLName()
{
	return getSetting("Entity Distribution XML Name");
}

Ogre::String SampleConfigFile::getEntitiesFolder()
{
	return getSetting("Entities Folder");
}


Ogre::String SampleConfigFile::getEntitiesMeshName()
{
	return getSetting("Entities Mesh Name");
}

Ogre::String SampleConfigFile::getBillboardCloudGroupedIndirectTexturingXMLName()
{
	return getSetting("Billboard Cloud Grouped Indirect Texturing XML Name");
}

bool SampleConfigFile::getEntitySampleMeshGeneration()
{
	return Ogre::StringConverter::parseBool(getSetting("Entity Sample Mesh Generation"));
}

bool SampleConfigFile::getEntityClustersGeneration()
{
	return Ogre::StringConverter::parseBool(getSetting("Entity Clusters Generation"));
}

float SampleConfigFile::getEntityClustersAlpha()
{
	return Ogre::StringConverter::parseReal(getSetting("Entity Clusters Alpha"));
}

unsigned int SampleConfigFile::getEntityClustersMaxClusters()
{
	return Ogre::StringConverter::parseInt(getSetting("Entity Clusters MaxClusters"));
}

unsigned int SampleConfigFile::getEntityClustersNumIterations()
{
	return Ogre::StringConverter::parseInt(getSetting("Entity Clusters NumIterations"));
}

bool SampleConfigFile::getEntityClustersGroupedClusters()
{
	return Ogre::StringConverter::parseBool(getSetting("Entity Clusters Grouped Clusters"));
}

bool SampleConfigFile::getEntityClustersSplittedClusters()
{
	return Ogre::StringConverter::parseBool(getSetting("Entity Clusters Splitted Clusters"));
}

bool SampleConfigFile::getEntityDistributionSplitted()
{
	return Ogre::StringConverter::parseBool(getSetting("Entity Distribution Splitted"));
}

bool SampleConfigFile::getBillboardCloudGroupedDiffuseColorBillboards()
{
	return Ogre::StringConverter::parseBool(getSetting("Billboard Cloud Grouped Diffuse Color Billboards"));
}

bool SampleConfigFile::getBillboardCloudSplittedBillboards()
{
	return Ogre::StringConverter::parseBool(getSetting("Billboard Cloud Splitted Billboards"));
}

Ogre::String SampleConfigFile::getBillboardCloudDiffuseColorPointClustersMeshName()
{
	return getSetting("Billboard Cloud Diffuse Color Point Clusters Mesh Name");
}

Ogre::String SampleConfigFile::getBillboardCloudDiffuseColorPointClustersMaterialName()
{
	return getSetting("Billboard Cloud Diffuse Color Point Clusters Material Name");
}

Ogre::String SampleConfigFile::getEntityClustersFolder()
{
	return getSetting("Entity Clusters Folder");
}

Ogre::String SampleConfigFile::getEntityClustersGroupedMeshName()
{
	return getSetting("Entity Clusters Grouped Mesh Name");
}

Ogre::String SampleConfigFile::getEntityClustersSplittedMeshName()
{
	return getSetting("Entity Clusters Splitted Mesh Name");
}

Ogre::String SampleConfigFile::getEntityClustersGroupedMaterialName()
{
	return getSetting("Entity Clusters Grouped Material Name");
}

Ogre::String SampleConfigFile::getEntityClustersSplittedMaterialName()
{
	return getSetting("Entity Clusters Splitted Material Name");
}

Ogre::String SampleConfigFile::getBillboardCloudFolder()
{
	return getSetting("Billboard Cloud Folder");
}

Ogre::String SampleConfigFile::getBillboardCloudGroupedDiffuseColorMeshName()
{
	return getSetting("Billboard Cloud Grouped Diffuse Color Mesh Name");
}

Ogre::String SampleConfigFile::getBillboardCloudGroupedIndirectTexturingMeshName()
{
	return getSetting("Billboard Cloud Grouped Indirect Texturing Mesh Name");
}

Ogre::String SampleConfigFile::getBillboardCloudSplittedMeshName()
{
	return getSetting("Billboard Cloud Splitted Mesh Name");
}

Ogre::String SampleConfigFile::getBillboardCloudGroupedIndirectTexturingMaterialName()
{
	return getSetting("Billboard Cloud Grouped Indirect Texturing Material Name");
}

Ogre::String SampleConfigFile::getBillboardCloudGroupedDiffuseColorMaterialName()
{
	return getSetting("Billboard Cloud Grouped Diffuse Color Material Name");
}

Ogre::String SampleConfigFile::getBillboardCloudSplittedMaterialName()
{
	return getSetting("Billboard Cloud Splitted Material Name");
}

Ogre::String SampleConfigFile::getEntityClustersGroupedTextureUnit0Name()
{
	return getSetting("Entity Clusters Grouped Texture Unit 0 Name");
}

Ogre::String SampleConfigFile::getEntityClustersSplittedTextureUnit0Name()
{
	return getSetting("Entity Clusters Splitted Texture Unit 0 Name");
}

Ogre::String SampleConfigFile::getBillboardCloudGroupedDiffuseColorTextureUnit0Name()
{
	return getSetting("Billboard Cloud Grouped Diffuse Color Texture Unit 0 Name");
}

Ogre::String SampleConfigFile::getBillboardCloudGroupedIndirectTexturingTextureUnit0Name()
{
	return getSetting("Billboard Cloud Grouped Indirect Texturing Texture Unit 0 Name");
}

Ogre::String SampleConfigFile::getBillboardCloudSplittedTextureUnit0Name()
{
	return getSetting("Billboard Cloud Splitted Texture Unit 0 Name");
}

Ogre::String SampleConfigFile::getBillboardCloudIndirectGroupedBillboardsTextureAtlasName()
{
	return getSetting("Billboard Cloud Indirect Grouped Billboards Texture Atlas Name");
}

unsigned int SampleConfigFile::getBillboardCloudDiffuseColorEntityTextureAtlasBitRange()
{
	return Ogre::StringConverter::parseInt(getSetting("Billboard Cloud Diffuse Color Entity Texture Atlas Bit Range"));
}

unsigned int SampleConfigFile::getBillboardCloudDiffuseColorGroupedBillboardsTextureSize()
{
	return Ogre::StringConverter::parseInt(getSetting("Billboard Cloud Diffuse Color Grouped Billboards Texture Size"));
}

unsigned int SampleConfigFile::getBillboardCloudGroupedIndirectTexturingGroups()
{
	return Ogre::StringConverter::parseInt(getSetting("Billboard Cloud Grouped Indirect Texturing Groups"));
}

unsigned int SampleConfigFile::getBillboardCloudGroupedDiffuseColorGroups()
{
	return Ogre::StringConverter::parseInt(getSetting("Billboard Cloud Grouped Diffuse Color Groups"));
}

unsigned int SampleConfigFile::getBillboardCloudDiffuseColorGroupedBillboardsTextureAtlasBitRange()
{
	return Ogre::StringConverter::parseInt(getSetting("Billboard Cloud Diffuse Color Grouped Billboards Texture Atlas Bit Range"));
}

unsigned int SampleConfigFile::getBillboardCloudIndirectGroupedBillboardsTextureAtlasBitRange()
{
	return Ogre::StringConverter::parseInt(getSetting("Billboard Cloud Indirect Grouped Billboards Texture Atlas Bit Range"));
}

unsigned int SampleConfigFile::getBillboardCloudIndirectGroupedBillboardsTextureAtlasSize()
{
	return Ogre::StringConverter::parseInt(getSetting("Billboard Cloud Indirect Grouped Billboards Texture Atlas Size"));
}

unsigned int SampleConfigFile::getBillboardCloudIndirectGroupedBillboardsTextureSize()
{
	return Ogre::StringConverter::parseInt(getSetting("Billboard Cloud Indirect Grouped Billboards Texture Size"));
}

unsigned int SampleConfigFile::getBillboardCloudDiffuseColorGroupedBillboardsTextureAtlasSize()
{
	return Ogre::StringConverter::parseInt(getSetting("Billboard Cloud Diffuse Color Grouped Billboards Texture Atlas Size"));
}

bool SampleConfigFile::getBillboardCloudDiffuseColorGroupedBillboardsTextureAtlasDebug()
{
	return Ogre::StringConverter::parseBool(getSetting("Billboard Cloud Diffuse Color Grouped Billboards Texture Atlas Debug"));
}

bool SampleConfigFile::getBillboardCloudIndirectGroupedBillboardsTextureAtlasDebug()
{
	return Ogre::StringConverter::parseBool(getSetting("Billboard Cloud Indirect Grouped Billboards Texture Atlas Debug"));
}

bool SampleConfigFile::getBillboardCloudDiffuseColorGroupedBillboardsTextureAtlasGeneration()
{
	return Ogre::StringConverter::parseBool(getSetting("Billboard Cloud Diffuse Color Grouped Billboards Texture Atlas Generation"));
}

bool SampleConfigFile::getBillboardCloudIndirectGroupedBillboardsTextureAtlasGeneration()
{
	return Ogre::StringConverter::parseBool(getSetting("Billboard Cloud Indirect Grouped Billboards Texture Atlas Generation"));
}

bool SampleConfigFile::getBillboardCloudGroupedIndirectTexturingBillboards()
{
	return Ogre::StringConverter::parseBool(getSetting("Billboard Cloud Grouped Indirect Texturing Billboards"));
}

bool SampleConfigFile::getBillboardCloudDiffuseColorEntityTextureAtlasGeneration()
{
	return Ogre::StringConverter::parseBool(getSetting("Billboard Cloud Diffuse Color Entity Texture Atlas Generation"));
}

Ogre::String SampleConfigFile::getBillboardCloudDiffuseColorEntityTextureName()
{
	return getSetting("Billboard Cloud Diffuse Color Entity Texture Name");
}

Ogre::String SampleConfigFile::getBillboardCloudDiffuseColorGroupedBillboardsTextureAtlasName()
{
	return getSetting("Billboard Cloud Diffuse Color Grouped Billboards Texture Atlas Name");
}

Ogre::String SampleConfigFile::getBillboardCloudDiffuseColorEntityTextureAtlasName()
{
	return getSetting("Billboard Cloud Diffuse Color Entity Texture Atlas Name");
}

unsigned int SampleConfigFile::getBillboardCloudDiffuseColorEntityTextureAtlasSize()
{
	return Ogre::StringConverter::parseInt(getSetting("Billboard Cloud Diffuse Color Entity Texture Atlas Size"));
}

unsigned int SampleConfigFile::getBillboardCloudDiffuseColorEntityTextureAtlasNumSamples()
{
	return Ogre::StringConverter::parseInt(getSetting("Billboard Cloud Diffuse Color Entity Texture Atlas NumSamples"));
}

Ogre::String SampleConfigFile::getBillboardCloudSplittedXMLName()
{
	return getSetting("Billboard Cloud Splitted XML Name");
}

Ogre::String SampleConfigFile::getBillboardCloudGroupedDiffuseColorXMLName()
{
	return getSetting("Billboard Cloud Grouped Diffuse Color XML Name");
}

}
